
;******************************************************
.include "2313def.inc"
;******************************************************

;	.def Zeile 	= r00	;0...8
;	.def Spalte	= r01	;0...23
;	.def Adresse	= r02	;Bit 0...4 - Spaltenadresse
				;Bit 5...7 - Zeilenadresse
;	.def Zeichen	= r03	;ASCII-Zeichen
;	.def 	= r04
;	.def 	= r05
;	.def 	= r06
;	.def 	= r07
;	.def 	= r08
;	.def	= r09
;	.def	= r10
;	.def	= r11
;	.def 	= r12
;	.def 	= r13
;	.def 	= r14
;	.def 	= r15
	.def TempA	= r16
	.def TempB	= r17
;	.def TempC	= r18
;	.def TempD 	= r19
;	.def TempE 	= r20
;	.def 	= r21
;	.def 	= r22
;	.def 	= r23
;	.def 	= r24
;	.def 	= r25
	.def HelpInt	= r26
	.def Zaehler1	= r27
;	.def Zaehler2	= r28
;	.def Zaehler3	= r29
;	.def RZlow	= r30	;Stringadresse low
;	.def RZhigh	= r31	;Stringadresse high

	.equ Teiler1 	= 0x01	;38400 Int./Sek. /  26 Sek.
	.equ Teiler8 	= 0x02	; 4800 Int./Sek. / 208 Sek.
	.equ Teiler64	= 0x03	;  600 Int./Sek. /1,67 mSek.
	.equ Teiler256	= 0x04	;  150 Int./Sek. /6,67 mSek
	.equ Teiler1024	= 0x05	; 37,5 Int./Sek. /26,7 mSek

	.equ RAMBegin	= 0x60	;Erste On-Chip SRAM-Adresse
	.equ RAMDigit	= 0x70	;Beginn der Digitadressen
;	.equ RAMEnd	= 0xDF	;Letzte On-Chip SRAM-Adresse

	.equ Enable	= 4	;Enable-Port
	.equ RW		= 5	;Schreib-Lese-Port
	.equ RS		= 6	;Daten-Steuer-Port
	.equ BF		= 3	;Bussy-Flag
	

.CSEG
.ORG 0000

;----------------------------------------------------------------------------

;	***  Interrupteinsprnge AT90S2313  ***

	rjmp	Reset		;Reset Handler
	reti			;Ext. IRQ0 Handler
	reti			;Ext. IRQ1 Handler
	reti			;Timer1 Capture Handler
	reti			;Timer1 compare Handler
	reti			;Timer1 Overflow Handler
	rjmp	Timer0		;Timer0 Overflow Handler
	reti			;UART RX Complete Handler
	reti			;UART Data Register Empty Handler
	reti			;UART TX Complete Handler
	reti			;Analog Comparator Handler

;----------------------------------------------------------------------------

;	***  Initialisierung  ***

Reset:	ldi	TempA,RAMEnd	
	out	SPL,TempA	;Stackpointer auf RAM-Ende

	clr	TempA		;Register loeschen
	out	PORTB,TempA	;Port B alles auf 0
	out	PORTD,TempA	;Port D alles auf 0
	out	DDRB,TempA	;Port B alles auf Input
	ser	TempA		;Register setzen
	out	DDRD,TempA	;Port D alles auf Output
	
	ldi	TempA,1<<TOIE0	;0000 0010  
	out	TIMSK,TempA	;Timer 0 Interrupt ein
	clr	TempA
	out	TCNT0,TempA	;Startwert des Timers = 0
	ldi	TempA,Teiler1024 
	out	TCCR0,TempA	;Timer starten mit Vorteiler 1024
	sei			;Interrupts generell aktivieren


;	---  Resetwarteschleife ca. 1 Sek.  ---
	rcall	Tim1S		;1 Sekumde warten, Power on
	rcall	InitDsp		;Display initialisieren
	rcall	Tim1S		;1 Sekumde warten, Power on
	rcall	Tim1S		;1 Sekumde warten, Power on



	ldi	TempA,0x00
	mov	Zeile,TempA
	ldi	TempA,0x00
	mov	Spalte,TempA
	ldi	RZhigh,High(2*Text01)
	ldi	RZlow,Low(2*Text01)
	rcall	StrZeSp
	rcall	Tim500m
	inc	Zeile
	ldi	RZhigh,High(2*Text02)
	ldi	RZlow,Low(2*Text02)
	rcall	StrZeSp
	rcall	Tim500m
	inc	Zeile
	ldi	RZhigh,High(2*Text03)
	ldi	RZlow,Low(2*Text03)
	rcall	StrZeSp
	rcall	Tim500m
	inc	Zeile
	ldi	RZhigh,High(2*Text04)
	ldi	RZlow,Low(2*Text04)
	rcall	StrZeSp
	rcall	Tim500m
	inc	Zeile
	ldi	RZhigh,High(2*Text05)
	ldi	RZlow,Low(2*Text05)
	rcall	StrZeSp
	rcall	Tim500m
	inc	Zeile
	ldi	RZhigh,High(2*Text06)
	ldi	RZlow,Low(2*Text06)
	rcall	StrZeSp
	rcall	Tim500m
	inc	Zeile
	ldi	RZhigh,High(2*Text07)
	ldi	RZlow,Low(2*Text07)
	rcall	StrZeSp
	rcall	Tim500m
	inc	Zeile
	ldi	RZhigh,High(2*Text08)
	ldi	RZlow,Low(2*Text08)
	rcall	StrZeSp






Loop99:	
	rjmp	Loop99		;dynamischer Halt





Text01:
	.db	0x80, 0x86
	.db	0x86, 0x86
	.db	0x86, 0x86
	.db	0x86, 0x86
	.db	0x86, 0x86
	.db	0x86, 0x86
	.db	0x86, 0x86
	.db	0x86, 0x86
	.db	0x86, 0x86
	.db	0x86, 0x86
	.db	0x86, 0x86
	.db	0x86, 0x81
	.db	0

Text02:
	.db	0x85, "Ansteuerung: AT90S2313", 0x84
	.db	0

Text03:
	.db	0x85, "Display: Samsung 0282A", 0x84
	.db	0

Text04:
	.db	0x85, "IC: M50530/Mitsubishi ", 0x84
	.db	0

Text05:
	.db	0x85, "8 Zeilen, 24 Zeichen  ", 0x84
	.db	0

Text06:
	.db	0x85, "erstellt: 25.11.2006  ", 0x84
	.db	0

Text07:
	.db	0x85, "(C) by R. Richter     ", 0x84
	.db	0

Text08:
	.db	0x82, 0x87
	.db	0x87, 0x87
	.db	0x87, 0x87
	.db	0x87, 0x87
	.db	0x87, 0x87
	.db	0x87, 0x87
	.db	0x87, 0x87
	.db	0x87, 0x87
	.db	0x87, 0x87
	.db	0x87, 0x87
	.db	0x87, 0x87
	.db	0x87, 0x83
	.db	0




;----------------------------------------------------------------------------

;	***  Unterprogramme  ***



;	---  Timer 0 Interrupt  ---
;       104 Sek. je Durchlauf (=Wert Zaehler1)

Timer0:
	reti

;	---  Warteschleifen ohne Interrupt  ---

Tim10S:	push	Zaehler1	;10 Sekunden
	ldi	Zaehler1,100
	rjmp	Timer4
Tim5S:	push	Zaehler1	;5 Sekunden
	ldi	Zaehler1,50
	rjmp	Timer4
Tim2S:	push	Zaehler1	;2 Sekunden
	ldi	Zaehler1,20
	rjmp	Timer4
Tim1S:	push	Zaehler1	;1 Sekunde
	ldi	Zaehler1,10
	rjmp	Timer4
Tim500m:push	Zaehler1	;1 Sekunde
	ldi	Zaehler1,5
	rjmp	Timer4
Tim200m:push	Zaehler1	;1 Sekunde
	ldi	Zaehler1,2
Timer4:	rcall	Tim100m
	dec	Zaehler1
	or	Zaehler1,Zaehler1
	brne	Timer4
	pop	Zaehler1
	ret

Tim100m:push	Zaehler1	;100 Millisekunden
	ldi	Zaehler1,100
	rjmp	Timer3
Tim10m:	push	Zaehler1	;10 Millisekunden
	ldi	Zaehler1,10
Timer3:	rcall	Tim1m
	dec	Zaehler1
	or	Zaehler1,Zaehler1
	brne	Timer3
	pop	Zaehler1
	ret

Tim1m:	push	Zaehler1	;1 Millisekunde
	ldi	Zaehler1,100
	rjmp	Timer2
Tim100:	push	Zaehler1	;100 Mikrosekunden
	ldi	Zaehler1,10
Timer2:	rcall	Tim10
	dec	Zaehler1
	or	Zaehler1,Zaehler1
	brne	Timer2
	pop	Zaehler1
	ret

Tim10:	push	Zaehler1	;10 Mikrosekunden
	ldi	Zaehler1,20
	rjmp	Timer1
Tim1:	push	Zaehler1	;1 Mikrosekunde
	ldi	Zaehler1,2
Timer1:	dec	Zaehler1
	or	Zaehler1,Zaehler1
	brne	Timer1
	pop	Zaehler1
	ret



;******************************************************
.include "0282Adef.inc"
;******************************************************

